inez/urls.py
from django.urls import path
from . import views

app_name = 'inez'

urlpatterns = [
    path('', views.homepage, name='homepage'),
    path('testimonial/', views.testimonial, name='testimonial'),
    path('post/', views.postView, name='postView'),
    path('editpost/<int:pk>/', views.editPostView, name='editPostView'),
    path('deletepost/<int:pk>', views.deletePost, name='deletePost'),
    path('deleteall/', views.deleteAllPost, name='deleteAllPost'),
    path('list_pet/', views.list_pet, name='list_pet'),
    path('list_photo/', views.list_photo, name='list_photo'),
    path('list_testimonial/', views.list_testimonial, name='list_testimonial'),
]

ppw_adopsi_hewan/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

from . import views

urlpatterns = [
    path('admin/', admin.site.urls),
    # path('', views.index, name='contoh'),
    path('', include('alghi.urls')),
    path('', include('shannia.urls')),
    path('', include('inez.urls')),
    path('', include('yoga.urls')),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL,
        document_root=settings.MEDIA_ROOT)

alghi/models.py
from django.db import models
from django.contrib.auth.models import User
from django.db.models.signals import post_save
from django.dispatch import receiver

class Profile(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    owner_phone = models.CharField(max_length = 50, blank=True)
    owner_country = models.CharField(max_length = 50, blank=True)
    owner_address = models.CharField(max_length = 200, blank=True)
    owner_city = models.CharField(max_length = 50, blank=True)
    owner_zipcode = models.CharField(max_length = 50, blank=True)

@receiver(post_save, sender=User)
def create_user_profile(sender, instance, created, **kwargs):
    if created:
        Profile.objects.create(user=instance)

@receiver(post_save, sender=User)
def save_user_profile(sender, instance, **kwargs):
    instance.profile.save()

class Pet(models.Model):
    PET_TYPE_CHOICES = [
        ("Cat", "Cat"),
        ("Dog", "Dog"),
        ("Other", "Other")
    ]

    PET_GENDER = [
        ("Male", "Male"),
        ("Female", "Female")
    ]

    PET_SIZE = [
        ("Small", "Small"),
        ("Medium", "Medium"),
        ("Large", "Large"),
        ("XL", "XL")
    ]

    PET_AGE = [
        ("Young", "Young"),
        ("Adult", "Adult"),
        ("Senior", "Senior")
    ]

    pet_name = models.CharField(max_length = 50)
    pet_type = models.CharField(max_length = 50, choices = PET_TYPE_CHOICES)
    pet_breed = models.CharField(max_length = 50)
    pet_gender = models.CharField(max_length = 50, choices = PET_GENDER)
    pet_size = models.CharField(max_length = 50, choices = PET_SIZE)
    pet_age = models.CharField(max_length = 50, choices = PET_AGE)
    pet_health = models.CharField(max_length = 50, default = "")
    adoption_fee = models.CharField(max_length = 50, default = "")
    description = models.TextField(max_length = 500)
    owner = models.ForeignKey(User, on_delete=models.CASCADE)

class PhotoPet(models.Model):
    photo = models.ImageField(upload_to='images/')
    pet = models.ForeignKey(Pet, on_delete=models.CASCADE)

inez/models.py
from django.db import models

# Create your models here.
class Testimonial(models.Model):
    name = models.CharField(max_length=50)
    occupation = models.CharField(max_length=50)
    testimonial = models.CharField(max_length=180)

alghi/forms.py
from django import forms

from .models import Pet

class PetForm(forms.ModelForm):
    class Meta:
        model = Pet
        fields = ['pet_name','pet_type','pet_breed','pet_gender','pet_size','pet_age','pet_health','adoption_fee','description','owner']

class PhotoForm(forms.Form):
    photo = forms.ImageField()

inez/forms.py
from django import forms
from .models import Testimonial
from django.forms import ModelForm

class TestimonialForm(ModelForm):
    class Meta:
        model = Testimonial
        fields = ['name', 'occupation', 'testimonial']
        labels = {
            'name' : 'Name', 'occupation' : 'Occupation', 'testimonial' : 'Testimonial'
        }
        widgets = {
            'name' : forms.TextInput(attrs={'class': 'form-control',
                                        'type' : 'text'}),
            'occupation' : forms.TextInput(attrs={'class': 'form-control',
                                        'type' : 'text'}),
            'testimonial' : forms.Textarea(attrs={'class': 'form-control',
                                        'type' : 'textarea', 'rows' : '4'}),
        }

inez/views.py
from django.shortcuts import render
from django.shortcuts import redirect
from .forms import TestimonialForm
from .models import Testimonial

from alghi.models import Pet, PhotoPet
from alghi.forms import PetForm

from django.http import JsonResponse
from django.conf import settings

# Create your views here.
def homepage(request):
    data = Testimonial.objects.all()
    pet_list = Pet.objects.all()[:3]
    photo_list = PhotoPet.objects.all()[:3]
    testimonial_count = data.count()

    content = {'title' : 'Testimonials',
                'data' : data,
                'pet_list' : pet_list,
                'photo_list' : photo_list,
                'testimonial_count' : testimonial_count}
    return render(request, 'homepage.html', content)

def testimonial(request):
    if request.method == 'POST':
        form = TestimonialForm(request.POST)
        if form.is_valid():
                post = form.save(commit=False)
                post.save()
                return redirect('inez:homepage')
    else:
        form = TestimonialForm()

    content = {'title' : 'Post Your Testimonial',
                'form' : form}

    return render(request, 'homepage.html', content)
    
def postView(request):
    if request.user.is_authenticated:
        pet_list = Pet.objects.filter(owner = request.user)
        photo_list = PhotoPet.objects.all()
        pet_count = pet_list.count()

        content = {'pet_list' : pet_list,
                    'photo_list' : photo_list,
                    'pet_count' : pet_count}

        return render(request, 'post.html', content)
    else:
        return redirect('/login_register/?needlogin')

def editPostView(request, pk):
    post = Pet.objects.get(pk=pk)
    if request.method == "POST":
        form = PetForm(request.POST, instance=post)
        if form.is_valid():
            post = form.save(commit=False)
            post.save()
            return redirect('inez:postView')
    else:
        form = PetForm(instance=post)

    content = {'form' : form,
                'list' : post}
    return render(request, 'edit_post.html', content)

def deletePost(request, pk):
    Pet.objects.filter(pk=pk).delete()
    data = Pet.objects.all()
    content = {'data' : data}
    return redirect('inez:postView')

def deleteAllPost(request):
    if request.method == "POST":
        Pet.objects.all().delete()
        data = Pet.objects.all()
        content = {'data' : data}
        return redirect('inez:postView')
    else:
        return redirect('inez:postView')

def list_pet(request):
    pet_list = list(Pet.objects.values())
    return JsonResponse(pet_list, safe=False)

def list_photo(request):
    photo_list = list(PhotoPet.objects.values())
    for i in range(len(photo_list)):
        photo_list[i]['photo'] = settings.MEDIA_URL + photo_list[i]['photo']
    return JsonResponse(photo_list, safe=False)

def list_testimonial(request):
    testimonial_list = list(Testimonial.objects.values())
    return JsonResponse(testimonial_list, safe=False)

inez/templates/edit_post.html
{% extends "base.html" %}

{% load static %}

{% block title %}AdopsiPet Edit post{% endblock %}

{% block styles %}
<link rel="stylesheet" type="text/css" href="{% static 'upload.css' %}">
{% endblock %}

{% block content %}
<h1 class="text-center pt-4">Edit Post</h1>
<div class="container py-4">
    <form method="POST" enctype="multipart/form-data" action="{% url 'inez:editPostView' pk=pet.pk %}">
    {% csrf_token %}

    <div class="row">
        <div class="col-md-6">
            <div class="form-group">
                <label for="id_pet_name">Pet name:</label>
                <input class="form-control" type="text" name="pet_name" maxlength="50" required="" id="id_pet_name">
            </div>
            
            <div class="form-group">
                <label for="id_pet_type">Pet type:</label>
                <select class="form-control" name="pet_type" required="" id="id_pet_type">
                    <option value="" selected="">---------</option>
                    <option value="Cat">Cat</option>
                    <option value="Dog">Dog</option>
                    <option value="Other">Other</option>
                </select>
            </div>
            
            <div class="form-group">
                <label for="id_pet_breed">Pet breed:</label>
                <input class="form-control" type="text" name="pet_breed" maxlength="50" required="" id="id_pet_breed">
            </div>
            
            <div class="form-group">
                <label for="id_pet_gender">Pet gender:</label>
                <select class="form-control" name="pet_gender" required="" id="id_pet_gender">
                    <option value="" selected="">---------</option>
                    <option value="Male">Male</option>
                    <option value="Female">Female</option>
                </select>
            </div>
        </div>
        <div class="col-md-6">
            <div class="form-group">
                <label for="id_pet_size">Pet size:</label>
                <select class="form-control" name="pet_size" required="" id="id_pet_size">
                    <option value="" selected="">---------</option>
                    <option value="Small">Small</option>
                    <option value="Medium">Medium</option>
                    <option value="Large">Large</option>
                    <option value="XL">XL</option>
                </select>
            </div>
            
            <div class="form-group">
                <label for="id_pet_age">Pet age:</label>
                <select class="form-control" name="pet_age" required="" id="id_pet_age">
                    <option value="" selected="">---------</option>
                    <option value="Young">Young</option>
                    <option value="Adult">Adult</option>
                    <option value="Senior">Senior</option>
                </select>
            </div>
            
            <div class="form-group">
                <label for="id_pet_health">Pet health:</label>
                <input class="form-control" type="text" name="pet_health" maxlength="50" required="" id="id_pet_health">
            </div>

            <div class="form-group">
                <label for="id_adoption_fee">Pet photo:</label><br>
                <input type="file" name="photo" accept="image/*" required="" id="id_photo">
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col">
            <div class="form-group">
                <label for="id_adoption_fee">Adoption fee:</label>
                <input class="form-control" type="text" name="adoption_fee" maxlength="50" required="" id="id_adoption_fee">
            </div>

            <div class="form-group">
                <label for="id_description">Description:</label>
                <textarea class="form-control" name="description" rows="5" maxlength="500" required="" id="id_description"></textarea>
            </div>
            <button class="btn orange-btn w-100" type="submit">Submit</button>
        </div>
    </div>
    </form>
</div>
{% endblock %}

inez/templates/homepage.html
<!DOCTYPE html>
{% extends "base.html" %}

{% load static %}

{% block title %}Welcome to AdopsiPet!{% endblock %}

{% block styles %}
<link rel="stylesheet" type="text/css" href="{% static 'css/homepage.css' %}">
<link rel="stylesheet" type="text/css" href="{% static 'css/docs.theme.min.css' %}">
<link rel="stylesheet" type="text/css" href="{% static 'css/owl.carousel.min.css' %}">
<link rel="stylesheet" type="text/css" href="{% static 'css/owl.theme.default.min.css' %}">
{% endblock %}

{% block content %}
    <div id="carouselExampleIndicators" class="carousel slide" data-ride="carousel">
        <ol class="carousel-indicators">
        <li data-target="#carouselExampleIndicators" data-slide-to="0" class="active"></li>
        <li data-target="#carouselExampleIndicators" data-slide-to="1"></li>
        </ol>
        <div class="carousel-inner">
            <div class="carousel-item active">
                <img class="d-block w-100" src="{% static 'images/homepage_background.jpg' %}" alt="First slide">
            </div>
            <div class="carousel-item">
                <img class="d-block w-100" src="{% static 'images/homepage_background_2.jpg' %}" alt="Second slide">
            </div>
        </div>
        <a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
        <span class="carousel-control-prev-icon" aria-hidden="true"></span>
        <span class="sr-only">Previous</span>
        </a>
        <a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
        <span class="carousel-control-next-icon" aria-hidden="true"></span>
        <span class="sr-only">Next</span>
        </a>
    </div>

    <div class="pet-available-section">
        <div class="row">
            <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12 col-xl-12" style="margin: 35px auto">
                <h1> 🐾 Pet Available for Adoption 🐾 </h1>
            </div>
        </div>
        <div class="row">
            {% for pet in pet_list %}
            <div class="col-md-3 px-2">
                <div class="pet-info pt-3 w-100">
                    {% for photo in photo_list %}
                        {% if photo.pet == pet %}
                            <div class="pet-photo mx-auto" style="
                                background: url('{{ photo.photo.url }}') no-repeat center center;
                                background-size: cover;
                                -webkit-background-size: cover;
                                -moz-background-size: cover;
                                -o-background-size: cover;
                                margin-top: 10px;
                            "></div>
                            <!-- <img src="{{ photo.photo.url }}" alt="pet photo"><br> -->
                        {% endif %}
                    {% endfor %}
                    <p style="font-size: 22px">{{ pet.pet_name }}
                        <br>
                        <i style="font-size: 16px">{{ pet.pet_type }} - {{ pet.pet_age }} - {{ pet.pet_breed }}</i>
                    </p>
                    <div class="more-info">
                        <a href="/detail/{{ pet.id }}/">
                            <p>More Info</p>
                        </a>
                    </div>
                </div>
            </div>
            {% endfor %}
            <div class="col-md-3 px-2">
                <div class="more-pet">
                    <img src="{% static 'images/dog_paw.png' %}">
                    <p>More pets are waiting for you</p>
                    <div class="more-pet-info">
                        <a href="/category/">
                            <p>Meet Them</p>
                        </a>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="testimonial-section">
        <div class="row">
            <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12 col-xl-12" style="margin: 35px auto">
                <h1> 🐾 Testimonials 🐾</h1>
            </div>
        </div>

        {% if testimonial_count > 0 %}  


        <!-- TESTIMONIALS -->
        <section class="testimonials">
        <div class="container">

        <div class="row">
            <div class="col-sm-12">
            <div id="customers-testimonials" class="owl-carousel">
                {% for list in data %}
                <div class="item">
                <div class="shadow-effect">
                    <img src="{% static 'images/testimonial_profile.png' %}">
                    <p>{{ list.testimonial }}</p>
                </div>
                <div class="testimonial-name">{{ list.name }}<br>{{ list.occupation }}</div>
                </div>
                {% endfor %}
            </div>
            </div>
        </div>
        </div>
        </section>
        <!-- END OF TESTIMONIALS -->

        {% else %}

        <div class="no-testimonial" style="text-align: center; font-family: BalooThambi; font-size: 25px">
            <img src="{% static 'images/for-pet-list.jpg' %}" style="width: 250px; height: 250px; margin: 0 auto">
            <p> Currently, there's no customer testimonial 😔</p>
            {% if user.is_authenticated %}
            <p>Please give us a feedback! ♡</p>
            {% endif %}
        </div>

        {% endif %}
    </div>

    {% if user.is_authenticated %}
    <div class="form-testimonial-section">
        <div class="row">
            <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12 col-xl-12" style="margin: 35px auto">
                <h1> 🐾 Post Your Testimonial 🐾 </h1>
            </div>
        </div>

        <div class="row">
            <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12 col-xl-12">
                <form method="POST" action="{% url 'inez:testimonial' %}">
                    {% csrf_token %}
                    <div class="form-group">
                        <label for="id_name">Name :</label>
                        <input class="form-control" type="text" name="name" maxlength="50" required="" id="id_name">
                    </div>
                    <div class="form-group">
                        <label for="id_occupation">Occupation :</label>
                        <input class="form-control" type="text" name="occupation" maxlength="50" required="" id="id_occupation">
                    </div>
                    <div class="form-group">
                        <label for="id_testimonial">Testimonial :</label>
                        <textarea class="form-control" name="testimonial" rows="4" maxlength="500" required="" id="id_testimonial"></textarea>
                    </div>

                    <button type="submit" class="btn btn-light"
                    style="background-color: #E85900; color: white; border-radius: 10px;
                    margin: 2.5% auto; float: right;
                    font-family: BalooThambi">Send</button>
                </form>
            </div>
        </div>
    </div>
    {% endif %}


{% endblock %}

{% block scripts %}
<script src="{% static 'js/owl.carousel.js' %}"></script>
<script src="{% static 'js/homepage.js' %}"></script>
{% endblock %}

inez/templates/post.html
<!DOCTYPE html>
{% extends "base.html" %}

{% load static %}

{% block title %}Post{% endblock %}

{% block styles %}
<link rel="stylesheet" type="text/css" href="{% static 'css/post.css' %}">
{% endblock %}

{% block content %}
<div class="list-post-pet">
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-10 col-lg-10 col-xl-10">
            <h1>Your Pet 🐾</h1>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-2 col-lg-2 col-xl-2" style="margin-top: 6%; margin-bottom: 2.5%">
            <form action="/upload/">
                <button type="submit" class="btn btn-light" style="background-color: #E85900; color: white; font-family: BalooThambi; font-size: 18px; margin-bottom: 2.5%; margin-left: 7.5%">Add Pet</button>
            </form>
            <form method="POST" action="{% url 'inez:deleteAllPost' %}">
                {% csrf_token %}
                <button type="submit" class="btn btn-icon btn-danger" style="font-family: BalooThambi; font-size: 18px; margin-left: 7.5%">Delete All</button>
            </form>
        </div>
    </div>

    {% if pet_count > 0 %}

    <div class="row" style="margin-top: 2.5%; margin-left: 5%; margin-right: 5%">
            {% for pet in pet_list %}
            <div class="col-xs-12 col-sm-7 col-md-5 col-lg-3 col-xl-3" style="margin: 2.5%">
                <div class="pet-info pt-3">
                    {% for photo in photo_list %}
                        {% if photo.pet == pet %}
                            <div class="pet-photo mx-auto" style="
                                background: url('{{ photo.photo.url }}') no-repeat center center;
                                background-size: cover;
                                -webkit-background-size: cover;
                                -moz-background-size: cover;
                                -o-background-size: cover;
                                margin-top: 10px;
                            "></div>
                            <!-- <img src="{{ photo.photo.url }}" alt="pet photo"><br> -->
                        {% endif %}
                    {% endfor %}
                    <p style="font-size: 22px">{{ pet.pet_name }}
                        <br>
                        <i style="font-size: 16px">{{ pet.pet_type }} - {{ pet.pet_age }} - {{ pet.pet_breed }}</i>
                    </p>
                    <div class="more-button" style="text-align: center;">
                        <a href="{% url 'pet_edit' pk=pet.pk %}"><button class="btn btn-icon btn-info" style="font-family: BalooThambi; background-color: #CE957A">Edit</button></a>
                        <a href="{% url 'inez:deletePost' pk=pet.pk %}"><button type="button" class="btn btn-icon btn-danger" style="font-family: BalooThambi; margin-left: 2.5%">Delete</button></a>
                    </div>
                </div>
            </div>
            {% endfor %}
        </div>

    {% else %}

    <div class="no-pet" style="text-align: center; font-family: BalooThambi; font-size: 25px">
        <img src="{% static 'images/for-pet-list.jpg' %}" style="width: 250px; height: 250px; margin: 0 auto">
        <p> Whoops! You haven't add any pet
            <br>
            Click 'Add Pet' to add your pet
        </p>
    </div>    

    {% endif %}

{% endblock %}